package cn.com.qmth.export;

import java.io.File;
import java.io.IOException;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;


public class MyProducer2 extends Producer {
	private static Logger logger = LogManager.getLogger(MyProducer2.class);
	private static String dir = "d:/chuannong/";
	private static String paperDir = "d:/chuannong/prop/";

	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		logger.info("***************************任务生产开始");
		String paperSuff = (String)param.get("paperSuff");
		String dbName = (String)param.get("dbName");
		File excelFolder = new File(paperDir);
		if (excelFolder.exists()) {
			FileUtil.clearDirectory(paperDir);
		} else {
			excelFolder.mkdirs();
		}
		Set<String> subjectCodes=readSubject();
		if(CollectionUtils.isEmpty(subjectCodes)) {
			return;
		}
		System.out.println("总科目数："+subjectCodes.size());
		for (String c : subjectCodes) {
			offer(new PaperExportDto(null,c, paperSuff,dbName));
		}
		logger.info("***************************任务生产结束");
	}
	
	
	private static LinkedHashSet<String> readSubject() {
		LinkedHashSet<String> list = new LinkedHashSet<>();
		XSSFWorkbook wb = null;
		try {
			wb = new XSSFWorkbook(dir + "subject_info.xlsx");
			XSSFSheet sheet = wb.getSheetAt(0);
			int rows = sheet.getLastRowNum();
			for (int i = 1; i <= rows; i++) {
				XSSFRow row = sheet.getRow(i);
				String yunkaiCode = row.getCell(1).getStringCellValue().trim();
				list.add(yunkaiCode);
			}
		} catch (IOException e) {
			throw new RuntimeException(e);
		} finally {
			if (wb != null) {
				try {
					wb.close();
				} catch (IOException e) {
				}
			}
		}
		return list;
	}
}
